Subject: Re: bug#65518: 30.0.50; [FR Eglot] Completions over all workspace symbols

From: Gerd Möllmann <[email-masked]>
Date: Sun, 27 Aug 2023 07:56:43 +0200

João Távora <[email-masked]> writes:

> João Távora <[email-masked]> writes:
>
>> If you want a comparative analysis to lsp-mode, to increase
>> the chances that this is addressed, I'd also need to know exactly
>> how you set it up.  As far as I understand, lsp-mode doesn't
>> do miracles, it uses the same LSP interfaces available to Eglot
>> (in this case, more than likely `symbol/workspace`, which I've
>> already described).
>
> Out of curiosity, I've had a look at lsp-mode.el.  It does not use
> 'symbol/workspace', rather 'textDocument/documentSymbol'.  So C-u
> M-. provides a complete list of symbols upfront.  But -- crucially --
> that list is limited to contain symbols for the current document only .
>
> So, at first glance, I'd say it's lsp-mode who is missing (lots and lots
> of) symbols.
>
> In contrast, Eglot's C-u M-. reaches all the symbols in the whole
> project, a much better implementation of 'xref-find-deinitions' IMNSHO.
> In a large project, like LLVM, using Eglot in combination with something
> like `M-x fido-vertical-mode` gives you an interactive incremental
> completion interface that is able reach millions of symbols across in
> thousands of C++ files.

Interesting.  Maybe I never noticed this because Emacs' C files include
so much that I got the impression that that was everything.

Thanks for testing this!

I guess we can close this request, then.  I'll see if can use etags, or
something, for that use-case.  Or just live with it.

Thanks!